<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria; 
use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DTO;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\MAN\Utilities;

class LogConsolidacaoVendas extends \Teknisa\MAN\Controllers\TeknisaCrud {

    
    protected $parameterBagColumns = array('CDFILIAL', 'CDCDLOJA', 'TCDFILIAL', 'TCDCDLOJA', 'NRORG', 'DATAINI', 'DATAFIN');
    protected $dataSourceName = 'vnd04601_relLogConsolidacao';
    
    public function __construct ( ParameterBag $parameterBag, Manager $dataSourceManager,  Utilities\Util $utilService, EntityManager $entityManager, $crudService   ) {
        $this->dataSourceManager = $dataSourceManager;
	    $this->parameterBag = $parameterBag;
	    $this->crudService =$crudService;
        $this->utilService = $utilService;
        $this->entityManager = $entityManager;
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = 'vnd04601_relLogConsolidacao';
        $conditions = $this->utilService->getParamsAsArray($request);
        $dataSourceFilter = array();
         
        if(array_key_exists('CDLOJA',$conditions)){
            $conditions['TCDLOJA'] = '';
            $conditions['CDLOJA'] = implode('_',$conditions['CDLOJA']);
        } else {
            $conditions['CDLOJA'] = '';
            $conditions['TCDLOJA'] = 'T';
        }
        if(array_key_exists('CDFILIAL',$conditions)){
            $conditions['TCDFILIAL'] = '';
            $conditions['CDFILIAL'] = implode('_',$conditions['CDFILIAL']);
        } else {
            $conditions['CDFILIAL'] = '';
            $conditions['TCDFILIAL'] = 'T';
        }
        $conditions['DATAINI'] = $conditions['DTENTRVENDA'][0];
        $conditions['DATAFIN'] = $conditions['DTENTRVENDA'][1];
        
        if (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'I'){
           if (empty($conditions['CDARVPRODF'])){
                $conditions['CDARVPRODF'] = $conditions['CDARVPRODI'];
           }
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDPRODLIST'] = null;
           $conditions['PRODNIV'] = null;
        }elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'D') {
           $conditions['PRODNIV'] = str_replace('%', '', str_replace('.', '', $conditions['PRODNIV'])).'%';
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDPRODLIST'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
        }
        elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'L'){
           $conditions['CDPRODLIST'] = implode('_', $conditions['CDPRODUTO']);
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
           $conditions['PRODNIV'] = null;
        }
        else{
           $conditions['TCDPRODUTO'] = 'T';
           $conditions['CDPRODLIST'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
           $conditions['PRODNIV'] = null;
        }
        
        unset($conditions['DTENTRVENDA']);
        unset($conditions['NMPRODUTO']);
        unset($conditions['CDPRODUTO']);
        unset($conditions['INTERVALISTA']);
        
        
        foreach($conditions as $key => $value) {
            $dataSourceFilter[] = array(
                "columnName" => $key,
                "operator"=> "=",
                "value"=> $value
            );
        }
        
        for($i = 0; $i < count($conditions); $i++) {
            if(strpos($dataSourceFilter[$i]["columnName"], '|') != false) {
                $dataSourceFilter[$i]["operator"] = "MAPPED_LIKE_ALL";
            }
        }
        
        $newRequest = new DTO\Request\Filter(
            new FilterCriteria(
                $request->getFilterCriteria()->getDataSourceName(),
                $dataSourceFilter,
                $request->getFilterCriteria()->getPage(),
                $request->getFilterCriteria()->getPageSize()
            ),
            $request->getMethod(),
            $request->getRoutePath(),
            $request->getUserId()
        );
        $this->parameterBagColumns =array('CDFILIAL', 'CDLOJA', 'TCDFILIAL', 'TCDLOJA', 'NRORG', 'DATAINI', 'DATAFIN', 'CDPRODLIST', 'CDARVPRODI', 'CDARVPRODF', 'PRODNIV', 'TCDPRODUTO');
        parent::find($newRequest, $response);
    }
}