<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\MAN\Services;
use Teknisa\MAN\Services\ReplicaProdutoFilial;

class ProdFilial extends  \Teknisa\MAN\Controllers\TeknisaCrud{

    protected $dataSourceProdFili       = 'vnd10003_prodFili';
    protected $dataSourceProdFiliAtu    = 'vnd10003_prodFili_atualiza';
	protected $parameterBagColumns      = array('NRORG', 'CDFILIAL', 'CDARVPRODINI', 'CDARVPRODFIN');

    protected $ProdFiliService;
    protected $ReplicaProdFiliProced;

	public function __construct ($crudService, $parameterBag, $entityManager, Services\ProdFili $ProdFiliService, ReplicaProdutoFilial $ReplicaProdFiliProced) {
		$this->crudService 				= $crudService;
		$this->parameterBag 			= $parameterBag;
		$this->entityManager 			= $entityManager;
        $this->ProdFiliService          = $ProdFiliService;
        $this->ReplicaProdFiliProced    = $ReplicaProdFiliProced;
	}

    public function findProdFili(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'vnd10003_prodFili';
        parent::find($request,$response);
    }

    public function saveProdFili(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = 'vnd10003_prodFili';
        $row = $request->getDataSet()->getRows();
        
    }

    public function exportaProdFili(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = 'vnd10003_prodFili';
        $row = $request->getDataSet()->getRows()[count($request->getDataSet()->getRows())-1];
        if (isset($row['CDFILIORIG']) && isset($row['CDFILIDEST'])){
            $params = array( 
                'CDFILIORIG' => $row['CDFILIORIG'],
                'CDFILIDEST' => $row['CDFILIDEST'],
                'IDTPFILDEST' => $row['IDTPFILDEST'],
                'IDTPCONFPAR' => $row['IDTPCONFPAR'],
                'CDPRODINIC' => $row['CDPRODINIC'],
                'CDPRODFINA' => $row['CDPRODFINA'],
                'LISTAPARAM' => $row['LISTAPARAM']
            );
            $this->ReplicaProdFiliProced->ExportaProdFili($params);
        }else{
            $CDFILIAL = $row['CDFILIAL'];
            $NRORG = $row['NRORG'];
            $this->ProdFiliService->refreshProduct($CDFILIAL, $NRORG);
        }
    }

    public function findAtualiza(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'vnd10003_prodFili_atualiza';
        parent::find($request,$response);
    }
}